Index: LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90	(revision 2641)
@@ -3320,119 +3356,232 @@
 #endif 
     END IF !type_trac = inca
-    !     
-    ! Calculer les parametres optiques des nuages et quelques
-    ! parametres pour diagnostiques:
-    !
-
-    IF (aerosol_couple.AND.config_inca=='aero') THEN 
-       mass_solu_aero(:,:)    = ccm(:,:,1) 
-       mass_solu_aero_pi(:,:) = ccm(:,:,2) 
-    END IF
-
-    if (ok_newmicro) then
-       IF (iflag_rrtm.NE.0) THEN 
+
+
+    !
+    ! Appeler le rayonnement mais calculer tout d'abord l'albedo du sol.
+    !
+    IF (MOD(itaprad,radpas).EQ.0) THEN
+
+       !
+       !jq - introduce the aerosol direct and first indirect radiative forcings
+       !jq - Johannes Quaas, 27/11/2003 (quaas@lmd.jussieu.fr)
+       IF (flag_aerosol .gt. 0) THEN
+          IF (iflag_rrtm .EQ. 0) THEN !--old radiation
+             IF (.NOT. aerosol_couple) THEN
+                !
+                CALL readaerosol_optic( &
+                     debut, new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
+                     pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
+                     mass_solu_aero, mass_solu_aero_pi,  &
+                     tau_aero, piz_aero, cg_aero,  &
+                     tausum_aero, tau3d_aero)
+             ENDIF
+          ELSE                       ! RRTM radiation
+             IF (aerosol_couple .AND. config_inca == 'aero' ) THEN
+                abort_message='config_inca=aero et rrtm=1 impossible'
+                call abort_physic(modname,abort_message,1)
+             ELSE
+                !
 #ifdef CPP_RRTM
-          IF (ok_cdnc.AND.NRADLP.NE.3) THEN
+                IF (NSW.EQ.6) THEN
+                   !--new aerosol properties
+                   !
+                   CALL readaerosol_optic_rrtm( debut, aerosol_couple, &
+                        new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
+                        pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
+                        tr_seri, mass_solu_aero, mass_solu_aero_pi,  &
+                        tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm,  &
+                        tausum_aero, tau3d_aero)
+
+                ELSE IF (NSW.EQ.2) THEN 
+                   !--for now we use the old aerosol properties
+                   !
+                   CALL readaerosol_optic( &
+                        debut, new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
+                        pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
+                        mass_solu_aero, mass_solu_aero_pi,  &
+                        tau_aero, piz_aero, cg_aero,  &
+                        tausum_aero, tau3d_aero)
+                   !
+                   !--natural aerosols
+                   tau_aero_sw_rrtm(:,:,1,:)=tau_aero(:,:,3,:)
+                   piz_aero_sw_rrtm(:,:,1,:)=piz_aero(:,:,3,:)
+                   cg_aero_sw_rrtm (:,:,1,:)=cg_aero (:,:,3,:)
+                   !--all aerosols
+                   tau_aero_sw_rrtm(:,:,2,:)=tau_aero(:,:,2,:)
+                   piz_aero_sw_rrtm(:,:,2,:)=piz_aero(:,:,2,:)
+                   cg_aero_sw_rrtm (:,:,2,:)=cg_aero (:,:,2,:)
+                ELSE
+                   abort_message='Only NSW=2 or 6 are possible with ' &
+                        // 'aerosols and iflag_rrtm=1'
+                   call abort_physic(modname,abort_message,1)
+                ENDIF
+
+                !--call LW optical properties for tropospheric aerosols 
+                !--only works for INCA aerosol (aerosol_couple = TRUE)
+                CALL aeropt_lw_rrtm(aerosol_couple,paprs,tr_seri)
+                !
+#else
+                abort_message='You should compile with -rrtm if running ' &
+                     // 'with iflag_rrtm=1'
+                call abort_physic(modname,abort_message,1)
+#endif
+                !
+             ENDIF
+          ENDIF
+       ELSE
+          tausum_aero(:,:,:) = 0.
+          mass_solu_aero(:,:) = 0.
+          mass_solu_aero_pi(:,:) = 0.
+          IF (iflag_rrtm .EQ. 0) THEN !--old radiation
+             tau_aero(:,:,:,:) = 1.e-15
+             piz_aero(:,:,:,:) = 1.
+             cg_aero(:,:,:,:)  = 0.
+          ELSE
+             tau_aero_sw_rrtm(:,:,:,:) = 1.e-15
+             tau_aero_lw_rrtm(:,:,:,:) = 1.e-15
+             piz_aero_sw_rrtm(:,:,:,:) = 1.0
+             cg_aero_sw_rrtm(:,:,:,:)  = 0.0
+          ENDIF
+       ENDIF
+       !
+       !--STRAT AEROSOL
+       !--updates tausum_aero,tau_aero,piz_aero,cg_aero
+       IF (flag_aerosol_strat.GT.0) THEN
+          IF (prt_level .GE.10) THEN
+             PRINT *,'appel a readaerosolstrat', mth_cur
+          ENDIF
+          IF (iflag_rrtm.EQ.0) THEN
+           IF (flag_aerosol_strat.EQ.1) THEN
+             CALL readaerosolstrato(debut)
+           ELSE
+             abort_message='flag_aerosol_strat must equal 1 for rrtm=0'
+             CALL abort_physic(modname,abort_message,1)
+           ENDIF
+          ELSE
+#ifdef CPP_RRTM
+            IF (flag_aerosol_strat.EQ.1) THEN
+             CALL readaerosolstrato1_rrtm(debut)
+            ELSEIF (flag_aerosol_strat.EQ.2) THEN
+             CALL stratosphere_mask(t_seri, pplay, latitude_deg)
+             CALL readaerosolstrato2_rrtm(debut)
+            ELSE
+             abort_message='flag_aerosol_strat must equal 1 or 2 for rrtm=1'
+             CALL abort_physic(modname,abort_message,1)
+            ENDIF
+#else
+             abort_message='You should compile with -rrtm if running ' &
+                  // 'with iflag_rrtm=1'
+             CALL abort_physic(modname,abort_message,1)
+#endif
+          ENDIF
+       ENDIF
+       !--fin STRAT AEROSOL
+       !     
+
+       ! Calculer les parametres optiques des nuages et quelques
+       ! parametres pour diagnostiques:
+       !
+       IF (aerosol_couple.AND.config_inca=='aero') THEN 
+          mass_solu_aero(:,:)    = ccm(:,:,1) 
+          mass_solu_aero_pi(:,:) = ccm(:,:,2) 
+       END IF
+
+       IF (ok_newmicro) then
+          IF (iflag_rrtm.NE.0) THEN 
+#ifdef CPP_RRTM
+             IF (ok_cdnc.AND.NRADLP.NE.3) THEN
              abort_message='RRTM choix incoherent NRADLP doit etre egal a 3 ' &
                   // 'pour ok_cdnc' 
-             call abort_physic(modname,abort_message,1)
-          endif
+             CALL abort_physic(modname,abort_message,1)
+             ENDIF
 #else
 
-          abort_message='You should compile with -rrtm if running with ' &
-               // 'iflag_rrtm=1'
-          call abort_physic(modname,abort_message,1)
+             abort_message='You should compile with -rrtm if running with '//'iflag_rrtm=1'
+             CALL abort_physic(modname,abort_message,1)
 #endif
+          ENDIF
+          CALL newmicro (ok_cdnc, bl95_b0, bl95_b1, &
+               paprs, pplay, t_seri, cldliq, cldfra, &
+               cldtau, cldemi, cldh, cldl, cldm, cldt, cldq, &
+               flwp, fiwp, flwc, fiwc, &
+               mass_solu_aero, mass_solu_aero_pi, &
+               cldtaupi, re, fl, ref_liq, ref_ice, &
+               ref_liq_pi, ref_ice_pi)
+       ELSE
+          CALL nuage (paprs, pplay, &
+               t_seri, cldliq, cldfra, cldtau, cldemi, &
+               cldh, cldl, cldm, cldt, cldq, &
+               ok_aie, &
+               mass_solu_aero, mass_solu_aero_pi, &
+               bl95_b0, bl95_b1, &
+               cldtaupi, re, fl)
        ENDIF
-       CALL newmicro (ok_cdnc, bl95_b0, bl95_b1, &
-            paprs, pplay, t_seri, cldliq, cldfra, &
-            cldtau, cldemi, cldh, cldl, cldm, cldt, cldq, &
-            flwp, fiwp, flwc, fiwc, &
-            mass_solu_aero, mass_solu_aero_pi, &
-            cldtaupi, re, fl, ref_liq, ref_ice, &
-            ref_liq_pi, ref_ice_pi)
-    else
-       CALL nuage (paprs, pplay, &
-            t_seri, cldliq, cldfra, cldtau, cldemi, &
-            cldh, cldl, cldm, cldt, cldq, &
-            ok_aie, &
-            mass_solu_aero, mass_solu_aero_pi, &
-            bl95_b0, bl95_b1, &
-            cldtaupi, re, fl)
-    endif
-    !
-    !IM betaCRF
-    !
-    cldtaurad   = cldtau
-    cldtaupirad = cldtaupi
-    cldemirad   = cldemi
-    cldfrarad   = cldfra
-
-    !
-    if(lon1_beta.EQ.-180..AND.lon2_beta.EQ.180..AND. &
-         lat1_beta.EQ.90..AND.lat2_beta.EQ.-90.) THEN
-       !
-       ! global
-       !
-       DO k=1, klev
-          DO i=1, klon
-             if (pplay(i,k).GE.pfree) THEN
-                beta(i,k) = beta_pbl
-             else
-                beta(i,k) = beta_free
-             endif
-             if (mskocean_beta) THEN
-                beta(i,k) = beta(i,k) * pctsrf(i,is_oce)
-             endif
-             cldtaurad(i,k)   = cldtau(i,k) * beta(i,k)
-             cldtaupirad(i,k) = cldtaupi(i,k) * beta(i,k)
-             cldemirad(i,k)   = cldemi(i,k) * beta(i,k)
-             cldfrarad(i,k)   = cldfra(i,k) * beta(i,k)
-          ENDDO
-       ENDDO
-       !
-    else
-       !
-       ! regional
-       !
-       DO k=1, klev
-          DO i=1,klon
-             !
-             if (longitude_deg(i).ge.lon1_beta.AND. &
-                  longitude_deg(i).le.lon2_beta.AND. &
-                  latitude_deg(i).le.lat1_beta.AND. &
-                  latitude_deg(i).ge.lat2_beta) THEN
-                if (pplay(i,k).GE.pfree) THEN
+       !
+       !IM betaCRF
+       !
+       cldtaurad   = cldtau
+       cldtaupirad = cldtaupi
+       cldemirad   = cldemi
+       cldfrarad   = cldfra
+
+       !
+       IF (lon1_beta.EQ.-180..AND.lon2_beta.EQ.180..AND. &
+           lat1_beta.EQ.90..AND.lat2_beta.EQ.-90.) THEN
+          !
+          ! global
+          !
+          DO k=1, klev
+             DO i=1, klon
+                IF (pplay(i,k).GE.pfree) THEN
                    beta(i,k) = beta_pbl
-                else
+                ELSE
                    beta(i,k) = beta_free
-                endif
-                if (mskocean_beta) THEN
+                ENDIF
+                IF (mskocean_beta) THEN
                    beta(i,k) = beta(i,k) * pctsrf(i,is_oce)
-                endif
+                ENDIF
                 cldtaurad(i,k)   = cldtau(i,k) * beta(i,k)
                 cldtaupirad(i,k) = cldtaupi(i,k) * beta(i,k)
                 cldemirad(i,k)   = cldemi(i,k) * beta(i,k)
                 cldfrarad(i,k)   = cldfra(i,k) * beta(i,k)
-             endif
+             ENDDO
+          ENDDO
+          !
+       ELSE
+          !
+          ! regional
+          !
+          DO k=1, klev
+             DO i=1,klon
+                !
+                IF (longitude_deg(i).ge.lon1_beta.AND. &
+                    longitude_deg(i).le.lon2_beta.AND. &
+                    latitude_deg(i).le.lat1_beta.AND.  &
+                    latitude_deg(i).ge.lat2_beta) THEN
+                   IF (pplay(i,k).GE.pfree) THEN
+                      beta(i,k) = beta_pbl
+                   ELSE
+                      beta(i,k) = beta_free
+                   ENDIF
+                   IF (mskocean_beta) THEN
+                      beta(i,k) = beta(i,k) * pctsrf(i,is_oce)
+                   ENDIF
+                   cldtaurad(i,k)   = cldtau(i,k) * beta(i,k)
+                   cldtaupirad(i,k) = cldtaupi(i,k) * beta(i,k)
+                   cldemirad(i,k)   = cldemi(i,k) * beta(i,k)
+                   cldfrarad(i,k)   = cldfra(i,k) * beta(i,k)
+                ENDIF
              !
+             ENDDO
           ENDDO
-       ENDDO
-       !
-    endif
-    !
-    ! Appeler le rayonnement mais calculer tout d'abord l'albedo du sol.
-    !
-    IF (MOD(itaprad,radpas).EQ.0) THEN
-
-       !albedo SB >>>  
-       if(ok_chlorophyll)then
+       !
+       ENDIF
+
+       !lecture de la chlorophylle pour le nouvel albedo de Sunghye Baek 
+       IF (ok_chlorophyll) THEN
           print*,"-- reading chlorophyll"
-          call readchlorophyll(debut)
-       endif
-       !do i=1,klon
-       !if(chl_con(i)>1.) print*,i,chl_con(i),pctsrf(i,is_ter)
-       !enddo
-       !albedo SB <<<
+          CALL readchlorophyll(debut)
+       ENDIF
 
 !--if ok_suntime_rrtm we use ancillay data for RSUN 
@@ -3483,5 +3632,4 @@
                cldtaupirad, &
                topswai_aero, solswai_aero)
-
 #endif
        ELSE
@@ -3498,5 +3646,4 @@
              print *,' ->radlwsw, number 1 '
           ENDIF
-
           !
           CALL radlwsw &
@@ -3569,5 +3716,5 @@
                                 !albedo SB <<<
                      t_seri,q_seri,wo, &
-                     cldfra, cldemi, cldtau, &
+                     cldfrarad, cldemirad, cldtaurad, &
                      ok_ade.OR.flag_aerosol_strat.GT.0, ok_aie, flag_aerosol, &
                      flag_aerosol_strat, &
@@ -3638,4 +3785,5 @@
     !
     radsol=solsw*swradcorr+sollw
+
     if (ok_4xCO2atm) then
        radsolp=solswp*swradcorr+sollwp
@@ -3654,6 +3802,6 @@
     ENDDO
 
-    CALL add_phys_tend(du0,dv0,d_t_swr,dq0,dql0,dqi0,paprs,'SW',abortphy)
-    CALL add_phys_tend(du0,dv0,d_t_lwr,dq0,dql0,dqi0,paprs,'LW',abortphy)
+    CALL add_phys_tend(du0,dv0,d_t_swr,dq0,dql0,dqi0,paprs,'SW',abortphy,flag_inhib_tend)
+    CALL add_phys_tend(du0,dv0,d_t_lwr,dq0,dql0,dqi0,paprs,'LW',abortphy,flag_inhib_tend)
 
     !
@@ -3739,5 +3887,5 @@
        ! ajout des tendances de la trainee de l'orographie
        CALL add_phys_tend(d_u_oro,d_v_oro,d_t_oro,dq0,dql0,dqi0,paprs,'oro', &
-            abortphy)
+            abortphy,flag_inhib_tend)
        !----------------------------------------------------------------------
        !
@@ -3785,5 +3933,5 @@
        ! ajout des tendances de la portance de l'orographie
        CALL add_phys_tend(d_u_lif, d_v_lif, d_t_lif, dq0, dql0, dqi0, paprs, &
-            'lif', abortphy)
+            'lif', abortphy,flag_inhib_tend)
     ENDIF ! fin de test sur ok_orolf
 
@@ -3808,5 +3956,5 @@
        d_t_hin(:, :)=0.
        CALL add_phys_tend(du_gwd_hines, dv_gwd_hines, d_t_hin, dq0, dql0, &
-            dqi0, paprs, 'hin', abortphy)
+            dqi0, paprs, 'hin', abortphy,flag_inhib_tend)
     ENDIF
 
@@ -3825,5 +3973,5 @@
 
        CALL add_phys_tend(du_gwd_front, dv_gwd_front, dt0, dq0, dql0, dqi0, &
-            paprs, 'front_gwd_rando', abortphy)
+            paprs, 'front_gwd_rando', abortphy,flag_inhib_tend)
     ENDIF
 
@@ -3833,5 +3981,5 @@
             du_gwd_rando, dv_gwd_rando, east_gwstress, west_gwstress)
        CALL add_phys_tend(du_gwd_rando, dv_gwd_rando, dt0, dq0, dql0, dqi0, &
-            paprs, 'flott_gwd_rando', abortphy)
+            paprs, 'flott_gwd_rando', abortphy,flag_inhib_tend)
        zustr_gwd_rando=0.
        zvstr_gwd_rando=0.
@@ -3896,5 +4044,5 @@
        ! ajout de la tendance d'humidite due au methane
        CALL add_phys_tend(du0, dv0, dt0, d_q_ch4*dtime, dql0, dqi0, paprs, &
-            'q_ch4', abortphy)
+            'q_ch4', abortphy,flag_inhib_tend)
     END IF
     !
@@ -3977,4 +4125,22 @@
        sh_in(:,:) = qx(:,:,ivap)
     END IF
+
+#ifdef CPP_Dust
+      CALL       phytracr_spl ( debut,lafin , jD_cur,jH_cur,iflag_con,       &  ! I
+                      pdtphys,ftsol,                                   &  ! I
+                      t,q_seri,paprs,pplay,RHcl,                  &  ! I
+                      pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,          &  ! I
+                      coefh(1:klon,1:klev,is_ave), cdragh, cdragm, u1, v1,                 &  ! I
+                      u_seri, v_seri, latitude_deg, longitude_deg,  &
+                      pphis,pctsrf,pmflxr,pmflxs,prfl,psfl,            &  ! I
+                      da,phi,phi2,d1a,dam,mp,ep,sigd,sij,clw,elij,     &  ! I
+                      epmlmMm,eplaMm,upwd,dnwd,itop_con,ibas_con,      &  ! I
+                      ev,wdtrainA,  wdtrainM,wght_cvfd,              &  ! I
+                      fm_therm, entr_therm, rneb,                      &  ! I
+                      beta_prec_fisrt,beta_prec, & !I
+                      zu10m,zv10m,wstar,ale_bl,ale_wake,               &  ! I
+                      d_tr_dyn,tr_seri)
+
+#else
 
     call phytrac ( &
@@ -4002,4 +4168,5 @@
          d_tr_dyn, &                                 !<<RomP
          tr_seri)
+#endif
 
     IF (offline) THEN
@@ -4333,4 +4500,12 @@
     !On effectue les sorties:
 
+#ifdef CPP_Dust
+  CALL phys_output_write_spl(itap, pdtphys, paprs, pphis,  &
+       pplay, lmax_th, aerosol_couple,                 &
+       ok_ade, ok_aie, ivap, new_aod, ok_sync,         &
+       ptconv, read_climoz, clevSTD,                   &
+       ptconvth, d_t, qx, d_qx, d_tr_dyn, zmasse,      &
+       flag_aerosol, flag_aerosol_strat, ok_cdnc)
+#else
     CALL phys_output_write(itap, pdtphys, paprs, pphis,  &
          pplay, lmax_th, aerosol_couple,                 &
@@ -4339,6 +4514,6 @@
          ptconvth, d_t, qx, d_qx, zmasse,                &
          flag_aerosol, flag_aerosol_strat, ok_cdnc)
-
-    include "write_histday_seri.h"
+#endif
+
 
     CALL write_paramLMDZ_phy(itap,nid_ctesGCM,ok_sync)
Index: LMDZ5/branches/testing/libf/phylmd/phytrac_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phytrac_mod.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/phytrac_mod.F90	(revision 2641)
@@ -570,17 +570,6 @@
     CASE('inca')
        !    -- CHIMIE INCA  config_inca = aero or chem --
-
-       CALL tracinca(&
-            nstep,    julien,   gmtime,         lafin,     &
-            pdtphys,  t_seri,   paprs,          pplay,     &
-            pmfu,     upwd,     ftsol,  pctsrf, pphis,     &
-            pphi,     albsol,   sh,             rh,        &
-            cldfra,   rneb,     diafra,         cldliq,    &
-            itop_con, ibas_con, pmflxr,         pmflxs,    &
-            prfl,     psfl,     aerosol_couple, flxmass_w, &
-            tau_aero, piz_aero, cg_aero,        ccm,       &
-            rfname,                                        &
-            tr_seri,  source)      
-
+       ! Appel fait en fin de phytrac pour avoir les emissions modifiees par 
+       ! la couche limite et la convection avant le calcul de la chimie 
     CASE('repr')
        !   -- CHIMIE REPROBUS --
@@ -895,4 +884,22 @@
     END IF !  lessivage
 
+
+    !    -- CHIMIE INCA  config_inca = aero or chem --
+    IF (type_trac == 'inca') THEN
+
+       CALL tracinca(&
+            nstep,    julien,   gmtime,         lafin,     &
+            pdtphys,  t_seri,   paprs,          pplay,     &
+            pmfu,     upwd,     ftsol,  pctsrf, pphis,     &
+            pphi,     albsol,   sh,             rh,        &
+            cldfra,   rneb,     diafra,         cldliq,    &
+            itop_con, ibas_con, pmflxr,         pmflxs,    &
+            prfl,     psfl,     aerosol_couple, flxmass_w, &
+            tau_aero, piz_aero, cg_aero,        ccm,       &
+            rfname,                                        &
+            tr_seri,  source)      
+       
+       
+    ENDIF
     !=============================================================
     !   Ecriture des sorties
Index: LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90	(revision 2641)
@@ -465,4 +465,5 @@
         PWV(i,k) = MAX (q(iof+i,k), 1.0e-12)
         PQS(i,k) = PWV(i,k)
+!       Confert from  column density of ozone in a cell, in kDU, to a mass fraction
         POZON(i,k, :) = wo(iof+i, k, :) * RG * dobson_u * 1e3 &
              / (paprs(iof+i, k) - paprs(iof+i, k+1))
Index: LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_5wv_rrtm.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_5wv_rrtm.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_5wv_rrtm.F90	(revision 2641)
@@ -94,10 +94,9 @@
   REAL :: od670aer(klon)  ! epaisseur optique aerosol extinction 670 nm
   REAL :: fac
-  REAL :: zdp1(klon,klev) 
   INTEGER, ALLOCATABLE, DIMENSION(:)  :: aerosol_name
   INTEGER :: nb_aer, itau
   LOGICAL :: ok_itau
   
-  REAL :: dh(KLON,KLEV)
+  REAL :: zdh(klon,klev)
   
    ! Soluble components 1- BC soluble; 2- POM soluble; 3- SO4 acc.; 4- SO4 coarse; 5 seasalt super-coarse; 6 seasalt coarse; 7 seasalt acc.
@@ -106,11 +105,8 @@
   REAL :: alpha_aeri_5wv(las,naero_insoluble)         ! Ext. coeff. ** m2/g 
 
-  REAL, DIMENSION(klon,klev,naero_tot) :: mass_temp
-  
   !
   ! Proprietes optiques
   !
   REAL :: fact_RH(nbre_RH)
-  LOGICAL :: used_tau(naero_tot)
   INTEGER :: n
 
@@ -209,12 +205,10 @@
   ai(:) = 0.
   tausum(:,:,:) = 0.
+  tau(:,:,:,:)=0.
 
   DO k=1, klev
     DO i=1, klon
       zrho=pplay(i,k)/t_seri(i,k)/RD                  ! kg/m3
-      dh(i,k)=pdel(i,k)/(RG*zrho)
-!CDIR UNROLL=naero_spc
-      mass_temp(i,k,:) = m_allaer(i,k,:) / zrho / 1.e+9
-      zdp1(i,k)=pdel(i,k)/(RG*delt)     ! air mass auxiliary  variable --> zdp1 [kg/(m^2 *s)]
+      zdh(i,k)=pdel(i,k)/(RG*zrho)                    ! m
     ENDDO
   ENDDO
@@ -270,15 +264,10 @@
   !      
 
-!CDIR ON_ADB(RH_tab)
-!CDIR ON_ADB(fact_RH)
-!CDIR NOVECTOR
   DO n=1,nbre_RH-1
     fact_RH(n)=1./(RH_tab(n+1)-RH_tab(n))
   ENDDO
    
-  DO k=1, KLEV
-!CDIR ON_ADB(RH_tab)
-!CDIR ON_ADB(fact_RH)
-    DO i=1, KLON
+  DO k=1, klev
+    DO i=1, klon
       rh(i,k)=MIN(RHcl(i,k)*100.,RH_MAX)
       RH_num(i,k) = INT( rh(i,k)/10. + 1.)
@@ -289,7 +278,4 @@
   ENDDO
 
-!CDIR SHORTLOOP  
-  used_tau(:)=.FALSE.
-    
   DO m=1,nb_aer   ! tau is only computed for each mass    
     fac=1.0
@@ -330,23 +316,19 @@
     ENDIF
 
-    IF (soluble) then
-      used_tau(spsol)=.TRUE.
-    ELSE
-      used_tau(naero_soluble+spinsol)=.TRUE.
-    ENDIF
-
     aerindex=aerosol_name(m)
 
     DO la=1,las
 
+    !--only 550, 670 and 865 nm are used
+    IF (la.NE.la550.AND.la.NE.la670.AND.la.NE.la865) CYCLE
+
       IF (soluble) THEN            ! For soluble aerosol
 
-          DO k=1, KLEV
-            DO i=1, KLON
+          DO k=1, klev
+            DO i=1, klon
               tau_ae5wv_int = alpha_aers_5wv(RH_num(i,k),la,spsol)+DELTA(i,k)* &
                              (alpha_aers_5wv(RH_num(i,k)+1,la,spsol) - & 
                               alpha_aers_5wv(RH_num(i,k),la,spsol))
-              tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)*   &
-                                    tau_ae5wv_int*delt*fac
+              tau(i,k,la,aerindex) = m_allaer(i,k,aerindex)/1.e6*zdh(i,k)*tau_ae5wv_int*fac
               tausum(i,la,aerindex)=tausum(i,la,aerindex)+tau(i,k,la,aerindex)
             ENDDO
@@ -355,9 +337,8 @@
       ELSE                         ! For insoluble aerosol
 
-        DO k=1, KLEV
-          DO i=1, KLON
+        DO k=1, klev
+          DO i=1, klon
             tau_ae5wv_int = alpha_aeri_5wv(la,spinsol)
-            tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)* &
-                                   tau_ae5wv_int*delt*fac
+            tau(i,k,la,aerindex) = m_allaer(i,k,aerindex)/1.e6*zdh(i,k)*tau_ae5wv_int*fac
             tausum(i,la,aerindex)= tausum(i,la,aerindex)+tau(i,k,la,aerindex)
           ENDDO
@@ -369,41 +350,14 @@
   ENDDO     ! Boucle sur les masses de traceurs
 
-  DO m=1,naero_tot
-    IF (.NOT.used_tau(m)) tau(:,:,:,m)=0.
-  ENDDO  
-
-  DO i=1, klon
-     od550aer(i)=0.
-     DO m=1,naero_tot
-        od550aer(i)=od550aer(i)+tausum(i,la550,m)
-     END DO
-  END DO
-
-  DO i=1, klon
-     od670aer(i)=0.
-     DO m=1,naero_tot
-        od670aer(i)=od670aer(i)+tausum(i,la670,m)
-     END DO
-  END DO
-
-  DO i=1, klon
-     od865aer(i)=0.
-     DO m=1,naero_tot
-        od865aer(i)=od865aer(i)+tausum(i,la865,m)
-     END DO
-  END DO
-
-  DO i=1, klon
-     DO k=1, KLEV
-        ec550aer(i,k)=0.
-        DO m=1,naero_tot
-           ec550aer(i,k)=ec550aer(i,k)+tau(i,k,la550,m)/dh(i,k)
-        END DO
-     END DO
-  END DO
-  
-  DO i=1, klon
-    ai(i)=-LOG(MAX(od670aer(i),1.e-8)/MAX(od865aer(i),1.e-8))/LOG(670./865.)
-  ENDDO
+!--AOD calculations for diagnostics
+  od550aer(:)=SUM(tausum(:,la550,:),dim=2)
+  od670aer(:)=SUM(tausum(:,la670,:),dim=2)
+  od865aer(:)=SUM(tausum(:,la865,:),dim=2)
+
+!--extinction coefficient for diagnostic
+  ec550aer(:,:)=SUM(tau(:,:,la550,:),dim=3)/zdh(:,:)
+
+!--aerosol index
+  ai(:)=-LOG(MAX(od670aer(:),1.e-8)/MAX(od865aer(:),1.e-8))/LOG(670./865.)
 
   od550lt1aer(:)=tausum(:,la550,id_ASSO4M_phy)+tausum(:,la550,id_ASBCM_phy) +tausum(:,la550,id_AIBCM_phy)+ &
Index: LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90	(revision 2641)
@@ -36,6 +36,6 @@
   !
   ! Output arguments:
-  ! 1= total aerosols 
-  ! 2= natural aerosols
+  ! 2= total aerosols 
+  ! 1= natural aerosols
   !
   REAL, DIMENSION(klon,klev,2,nbands_sw_rrtm), INTENT(out) :: tau_allaer ! epaisseur optique aerosol
@@ -66,16 +66,12 @@
   REAL :: Fact_RH(nbre_RH)
   REAL :: fac
-  REAL :: zdp1(klon,klev) 
+  REAL :: zdh(klon,klev) 
   INTEGER, ALLOCATABLE, DIMENSION(:)   :: aerosol_name
   INTEGER :: nb_aer
 
-  REAL, DIMENSION(klon,klev,naero_tot) :: mass_temp
-  REAL, DIMENSION(klon,klev,naero_tot) :: mass_temp_pi
   REAL, DIMENSION(klon,klev,naero_tot,nbands_sw_rrtm) ::  tau_ae
   REAL, DIMENSION(klon,klev,naero_tot,nbands_sw_rrtm) ::  tau_ae_pi
   REAL, DIMENSION(klon,klev,naero_tot,nbands_sw_rrtm) ::  piz_ae
   REAL, DIMENSION(klon,klev,naero_tot,nbands_sw_rrtm) ::  cg_ae
-
-
   !
   ! Proprietes optiques
@@ -89,5 +85,4 @@
 
   INTEGER :: id
-  LOGICAL :: used_aer(naero_tot)
   REAL :: tmp_var, tmp_var_pi
 
@@ -277,4 +272,5 @@
   spsol = 0
   spinsol = 0 
+
   IF (NSW.NE.nbands_sw_rrtm) THEN
      print *,'Erreur NSW doit etre egal a 6 pour cette routine'
@@ -282,13 +278,5 @@
   ENDIF
 
-  DO k=1, klev
-    DO i=1, klon
-!CDIR UNROLL=naero_tot
-      mass_temp(i,k,:) = m_allaer(i,k,:) / zrho(i,k) / 1.e+9  !--kg/kg
-!CDIR UNROLL=naero_tot
-      mass_temp_pi(i,k,:) = m_allaer_pi(i,k,:) / zrho(i,k) / 1.e+9
-      zdp1(i,k)=pdel(i,k)/(RG*delt)      ! air mass auxiliary  variable --> zdp1 [kg/(m^2 *s)]
-    ENDDO
-  ENDDO
+  zdh(:,:)=pdel(:,:)/(RG*zrho(:,:))      ! m
 
   IF (flag_aerosol .EQ. 1) THEN 
@@ -339,14 +327,10 @@
   !      compute optical_thickness_at_gridpoint_per_species
 
-!!CDIR ON_ADB(RH_tab)
-!CDIR ON_ADB(fact_RH)
-!CDIR SHORTLOOP
   DO n=1,nbre_RH-1
     fact_RH(n)=1./(RH_tab(n+1)-RH_tab(n))
   ENDDO
    
-  DO k=1, KLEV
-!CDIR ON_ADB(fact_RH)
-    DO i=1, KLON
+  DO k=1, klev
+    DO i=1, klon
       rh(i,k)=MIN(RHcl(i,k)*100.,RH_MAX)
       RH_num(i,k) = INT(rh(i,k)/10. + 1.)
@@ -357,5 +341,8 @@
   ENDDO
 
-  used_aer(:)=.FALSE.
+  tau_ae(:,:,:,:)=0.
+  tau_ae_pi(:,:,:,:)=0.
+  piz_ae(:,:,:,:)=0.
+  cg_ae(:,:,:,:)=0.
     
   DO m=1,nb_aer   ! tau is only computed for each mass
@@ -398,12 +385,11 @@
 
     id=aerosol_name(m)
-    used_aer(id)=.TRUE.
 
     IF (soluble) THEN
 
-       DO k=1, KLEV
-         DO i=1, KLON
-           tmp_var=mass_temp(i,k,spsol)*1000.*zdp1(i,k)*delt*fac
-           tmp_var_pi=mass_temp_pi(i,k,spsol)*1000.*zdp1(i,k)*delt*fac
+       DO k=1, klev
+         DO i=1, klon
+           tmp_var=m_allaer(i,k,spsol)/1.e6*zdh(i,k)*fac
+           tmp_var_pi=m_allaer_pi(i,k,spsol)/1.e6*zdh(i,k)*fac
 
            DO inu=1,NSW
@@ -432,8 +418,8 @@
      ELSE    ! For all aerosol insoluble components
 
-       DO k=1, KLEV
-         DO i=1, KLON
-           tmp_var=mass_temp(i,k,naero_soluble+ spinsol)*1000.*zdp1(i,k)*delt*fac
-           tmp_var_pi=mass_temp_pi(i,k,naero_soluble+spinsol)*1000.*zdp1(i,k)*delt*fac
+       DO k=1, klev
+         DO i=1, klon
+           tmp_var=m_allaer(i,k,naero_soluble+spinsol)/1.e6*zdh(i,k)*fac
+           tmp_var_pi=m_allaer_pi(i,k,naero_soluble+spinsol)/1.e6*zdh(i,k)*fac
 
            DO inu=1,NSW
@@ -454,16 +440,7 @@
   ENDDO  ! nb_aer  
 
-  DO m=1,naero_tot
-    IF (.NOT. used_aer(m)) THEN
-      tau_ae(:,:,m,:)=0.
-      tau_ae_pi(:,:,m,:)=0.
-      piz_ae(:,:,m,:)=0.
-      cg_ae(:,:,m,:)=0.
-    ENDIF
-  ENDDO
-
   DO inu=1, NSW 
-     DO k=1, KLEV
-       DO i=1, KLON
+     DO k=1, klev
+       DO i=1, klon
 !--anthropogenic aerosol
          tau_allaer(i,k,2,inu)=tau_ae(i,k,id_ASSO4M_phy,inu)+tau_ae(i,k,id_CSSO4M_phy,inu)+ &
@@ -536,9 +513,9 @@
     ENDDO
    
-!--???????
-  inu=1
-  DO i=1, KLON
-     absvisaer(i)=SUM((1-piz_allaer(i,:,:,inu))*tau_allaer(i,:,:,inu))
-  END DO	
+!--waveband 2 and all aerosol
+  inu=2
+  DO i=1, klon
+     absvisaer(i)=SUM((1-piz_allaer(i,:,2,inu))*tau_allaer(i,:,2,inu))
+  ENDDO
 
   DEALLOCATE(aerosol_name) 
Index: LMDZ5/branches/testing/libf/phylmd/rrtm/rrtm_ecrt_140gp.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/rrtm_ecrt_140gp.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/rrtm_ecrt_140gp.F90	(revision 2641)
@@ -31,5 +31,5 @@
  & JPINPX  
 USE YOERAD   , ONLY : NLW      ,NOVLP
-USE YOERDI   , ONLY :    RCH4     ,RN2O    ,RCFC11  ,RCFC12
+!MPL/IM 20160915 on prend GES de phylmd USE YOERDI   , ONLY :    RCH4     ,RN2O    ,RCFC11  ,RCFC12
 USE YOESW    , ONLY : RAER
 
@@ -113,4 +113,6 @@
 REAL(KIND=JPRB) :: ZHOOK_HANDLE
 
+!MPL/IM 20160915 on prend GES de phylmd
+#include "clesphys.h"
 ! ***
 
@@ -400,5 +402,5 @@
 
 !     ------------------------------------------------------------------
-
+ 
 IF (LHOOK) CALL DR_HOOK('RRTM_ECRT_140GP',1,ZHOOK_HANDLE)
 END SUBROUTINE RRTM_ECRT_140GP
Index: LMDZ5/branches/testing/libf/phylmd/rrtm/srtm_srtm_224gp_mcica.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/srtm_srtm_224gp_mcica.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/srtm_srtm_224gp_mcica.F90	(revision 2641)
@@ -16,5 +16,5 @@
 
 USE PARSRTM  , ONLY : JPLAY
-USE YOERDI   , ONLY : RCH4   , RN2O   
+!MPL/IM 20160915 on prend GES de phylmd USE YOERDI   , ONLY : RCH4   , RN2O   
 USE YOERAD   , ONLY : NAER
 USE YOESRTAER, ONLY : RSRTAUA, RSRPIZA, RSRASYA
@@ -133,5 +133,6 @@
 #include "srtm_setcoef.intfb.h"
 #include "srtm_spcvrt_mcica.intfb.h"
-
+!MPL/IM 20160915 on prend GES de phylmd
+#include "clesphys.h"
 
 !-----------------------------------------------------------------------
Index: LMDZ5/branches/testing/libf/phylmd/rrtm/suecrad.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/suecrad.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/suecrad.F90	(revision 2641)
@@ -245,4 +245,5 @@
 #include "naerad.h"
 #include "namrgri.h"
+!MPL/IM 20160915 on prend GES de phylmd
 #include "clesphys.h"
 
@@ -449,11 +450,21 @@
 
 ! Valeurs LMDZ (physiq.def) MPL 18052010
-RCCO2   = 348.E-06_JPRB
-RCCH4   = 1.65E-06_JPRB
-RCN2O   = 306.E-09_JPRB
-RCCFC11 = 280.E-12_JPRB
-RCCFC12 = 484.E-12_JPRB
-print *,'SUECRAD-1'
-
+!RCCO2   = 348.E-06_JPRB
+!RCCH4   = 1.65E-06_JPRB
+!RCN2O   = 306.E-09_JPRB
+!RCCFC11 = 280.E-12_JPRB
+!RCCFC12 = 484.E-12_JPRB
+
+!MPL/IM 20160915 on prend GES de phylmd
+RCCO2   = CO2_ppm * 1.0e-06
+RCCH4   = CH4_ppb * 1.0e-09
+RCN2O   = N2O_ppb * 1.0e-09
+RCCFC11 = CFC11_ppt * 1.0e-12
+RCCFC12 = CFC12_ppt * 1.0e-12
+!print *,'LMDZSUECRAD-1 RCCO2=',RCCO2
+!print *,'LMDZSUECRAD-1 RCCH4=',RCCH4
+!print *,'LMDZSUECRAD-1 RCN2O=',RCN2O
+!print *,'LMDZSUECRAD-1 RCCFC11=',RCCFC11
+!print *,'LMDZSUECRAD-1 RCCFC12=',RCCFC12
 !     ------------------------------------------------------------------
 
